package se.petterhansson.gp;

public class Test implements RandomSource<GPNode> {
	public static void main(String[] args) {
		new Test().run();
	}

	private void run() {
		Individual<GPNode> individual = new Individual<GPNode>(6, 4, this);
		System.out.println(individual.toString());
	}
	
	private static class TestFunction1 extends GPNode {
		public TestFunction1() {
			super(2);
		}

		@Override
		public String getPrefix() {
			return "+";
		}
	}
	
	private static class TestFunction2 extends GPNode {
		public TestFunction2() {
			super(2);
		}

		@Override
		public String getPrefix() {
			return "*";
		}
	}
	
	private static class TestTerminal extends GPNode {
		public TestTerminal() {
			super(0);
		}

		@Override
		public String getPrefix() {
			return "x";
		}
	}

	@Override
	public GPNode createRandomNode(boolean mayTerminate) {
		if (mayTerminate && Math.random() < 0.3) {
			return createRandomTerminal();
		}
		
		if (Math.random() < 0.5) {
			return new TestFunction1();
		}
		
		return new TestFunction2();
	}

	@Override
	public GPNode createRandomTerminal() {
		return new TestTerminal();
	}
}
