package se.petterhansson.sevengp.game;

public class Cards {
	public static final int SUIT_DIAMOND = 0;
	public static final int SUIT_CLUB = 1;
	public static final int SUIT_HEART = 2;
	public static final int SUIT_SPADE = 3;
	
	public static final int RANK_ZERO = 1;
	
	public static int getRank(int card) {
		return card % 13;
	}
	
	public static int getSuit(int card) {
		return card / 13;
	}
	
	public static String getString(int card) {
		int rank = getRank(card);
		
		String rankS;
		if (rank == 0) {
			rankS = "A";
		}
		else if (rank == 12) {
			rankS = "K";
		}
		else if (rank == 11) {
			rankS = "Q";
		}
		else if (rank == 10) {
			rankS = "k";
		}
		else if (rank == 9) {
			rankS = "10";
		}
		else {
			rankS = "" + (char) ('1' + rank);
		}
		
		int suit = getSuit(card);
		String suitS;
		if (suit == SUIT_DIAMOND) {
			suitS = "d";
		}
		else if (suit == SUIT_CLUB) {
			suitS = "c";
		}
		else if (suit == SUIT_HEART) {
			suitS = "h";
		}
		else if (suit == SUIT_SPADE) {
			suitS = "s";
		}
		else {
			suitS = "?";
		}
		
		return suitS + rankS;
	}
}
