package se.petterhansson.sevengp.game;

import java.util.ArrayList;
import java.util.Iterator;

public abstract class SevenPlayer implements Iterable<Integer> {
	protected final SevenGame myGame;
	protected final int myIndex;
	protected final ArrayList<Integer> cards = new ArrayList<Integer>();
	
	public SevenPlayer(SevenGame game, int index, int[] cards) {
		this.myGame = game;
		this.myIndex = index;

		for (int i = 0; i < cards.length; ++i) {
			this.cards.add(cards[i]);
		}
	}
	
	public String toString() {
		StringBuilder str = new StringBuilder();
		str.append("Player ");
		str.append(myIndex);
		str.append("\nCards:\n");
		
		for (int card : this) {
			str.append(Cards.getString(card));
			str.append(' ');
		}
		
		return str.toString();
	}

	@Override
	public Iterator<Integer> iterator() {
		return cards.iterator();
	}

	public abstract int playCard();

	public abstract int sendCard();

	public abstract void receiveCard(int card);

	public int countCards() {
		return cards.size();
	}

	public int getPlayerIndex() {
		return myIndex;
	}
}
