package se.petterhansson.sevengp.game;

public class TestSevenPlayer extends SevenPlayer {
	private final boolean printStuff;

	public TestSevenPlayer(SevenGame game, int index, int[] cards, boolean printStuff) {
		super(game, index, cards);
		this.printStuff = printStuff;
	}

	@Override
	public int playCard() {
		for (int i = 0, n = cards.size(); i < n; ++i) {
			int card = cards.get(i);
			if (myGame.canCardBePlayed(card)) {
				cards.remove(i);
				
				if (printStuff) {
					System.out.println("Player " + myIndex + " played card " + Cards.getString(card));
				}
				
				return card;
			}
		}
		
		throw new RuntimeException("No card to play");
	}

	@Override
	public void receiveCard(int card) {
		cards.add(card);
		
		if (printStuff) {
			System.out.println("Player " + myIndex + " received card " + Cards.getString(card));
		}
	}

	@Override
	public int sendCard() {
		int card = cards.remove(0);
		
		if (printStuff) {
			System.out.println("Player " + myIndex + " sent card " + Cards.getString(card));
		}
		
		return card;
	}
}
