package se.petterhansson.sevengp.gp;

import java.util.Random;

import se.petterhansson.gp.RandomSource;
import se.petterhansson.sevengp.gp.alphabet.AddFunction;
import se.petterhansson.sevengp.gp.alphabet.BlockTerminal;
import se.petterhansson.sevengp.gp.alphabet.ConstTerminal;
import se.petterhansson.sevengp.gp.alphabet.DistTerminal;
import se.petterhansson.sevengp.gp.alphabet.MulFunction;
import se.petterhansson.sevengp.gp.alphabet.RandTerminal;
import se.petterhansson.sevengp.gp.alphabet.RankTerminal;
import se.petterhansson.sevengp.gp.alphabet.RoundTerminal;
import se.petterhansson.sevengp.gp.alphabet.SafeTerminal;
import se.petterhansson.sevengp.gp.alphabet.SelfBlockTerminal;
import se.petterhansson.sevengp.gp.alphabet.SevenGPNode;
import se.petterhansson.sevengp.gp.alphabet.SuitTerminal;

public class SevenRandomSource implements RandomSource<SevenGPNode> {
	private Random random = new Random();
	
	@Override
	public SevenGPNode createRandomNode(boolean mayTerminate) {
		if (mayTerminate && Math.random() < 0.5) {
			return createRandomTerminal();
		}
		
		//uniform distribution
		int r = random.nextInt(2);
		if (r == 0) {
			return new AddFunction();
		}
		if (r == 1) {
			return new MulFunction();
		}
		/*if (r == 2) {
			return new LogFunction();
		}
		if (r == 2) {
			return new DivFunction();
		}
		if (r == 3) {
			return new IfFunction();
		}*/
		/*if (r == 4) {
			return new MaxFunction();
		}
		if (r == 5) {
			return new MinFunction();
		}*/

		throw new RuntimeException("No function");
	}

	@Override
	public SevenGPNode createRandomTerminal() {
		//uniform distribution
		int r = random.nextInt(10);
		
		if (r == 0) {
			return new RankTerminal();
		}
		if (r == 1) {
			return new SuitTerminal();
		}
		if (r == 2 || r == 3) {
			return new ConstTerminal();
		}
		if (r == 4) {
			return new DistTerminal();
		}
		if (r == 5) {
			return new RoundTerminal();
		}
		if (r == 6) {
			return new RandTerminal();
		}
		if (r == 7) {
			return new BlockTerminal();
		}
		if (r == 8) {
			return new SelfBlockTerminal();
		}
		if (r == 9) {
			return new SafeTerminal();
		}
		
		throw new RuntimeException("No terminal");
	}
}
