package se.petterhansson.sevengp.gp;

import java.util.HashSet;
import java.util.Set;

import se.petterhansson.gp.Individual;
import se.petterhansson.sevengp.game.SevenGame;
import se.petterhansson.sevengp.game.SevenPlayer;
import se.petterhansson.sevengp.game.SevenPlayerFactory;
import se.petterhansson.sevengp.game.TestSevenPlayer;
import se.petterhansson.sevengp.gp.alphabet.SevenGPNode;

public class Test {
	private SevenRandomSource src = new SevenRandomSource();
	
	public static void main(String[] args) {
		System.out.println("test1");
		new Test().run1();
		System.out.println();
		
		System.out.println("test2");
		new Test().run2();
		System.out.println();
	}
	
	private void run1() {
		Individual<SevenGPNode> parent = new Individual<SevenGPNode>(6, 4, src);
		System.out.println("parent");
		System.out.println(parent);
		
		Individual<SevenGPNode> copy = new Individual<SevenGPNode>(parent);
		HashSet<SevenGPNode> set1 = new HashSet<SevenGPNode>();
		HashSet<SevenGPNode> set2 = new HashSet<SevenGPNode>();
		addReferencedNodesToSet(parent.getRoot(), set1);
		addReferencedNodesToSet(copy.getRoot(), set2);
		set1.retainAll(set2);
		if (set1.size() > 1) { //1 is the null
			throw new RuntimeException("Set check failed - " + (set1.size() - 1) + " common nodes");
		}
		
		Individual<SevenGPNode> mutant = new Individual<SevenGPNode>(6, parent, src);
		System.out.println("mutant");
		System.out.println(mutant);
		
		//System.out.println("parent (should not have been modified)");
		//System.out.println(parent);
		
		Individual<SevenGPNode> cross = new Individual<SevenGPNode>(parent, mutant);
		System.out.println("cross");
		System.out.println(cross);
	}

	private void addReferencedNodesToSet(SevenGPNode node, Set<SevenGPNode> set) {
		if (node == null) {
			return;
		}
		
		set.add(node);
		set.add((SevenGPNode) node.getParent());
		
		for (int i = 0, n = node.getArity(); i < n; ++i) {
			addReferencedNodesToSet((SevenGPNode) node.getChild(i), set);
		}
	}

	private void run2() {
		SevenGame game = new SevenGame(2, new SevenPlayerFactory() {
			@Override
			public SevenPlayer createSevenPlayer(SevenGame game, int index, int[] cards) {
				if (index == 0) {
					return new TestSevenPlayer(game, index, cards, true);
				}
				
				return null;
				//return new SevenGPPlayer(game, index, cards);
			}
		});
		
		System.out.print("Start player: ");
		System.out.println(game.getCurrentPlayer());
		
		while (!game.isFinished()) {
			game.nextPlayer();
		}
		
		System.out.print("Winner: ");
		System.out.println(game.getWinner().getPlayerIndex());
	}
}
