package se.petterhansson.sevengp.gp.alphabet;

import se.petterhansson.sevengp.game.Cards;


public class BlockTerminal extends SevenGPNode {
	public BlockTerminal() {
		super(0);
	}

	@Override
	public float getValue(SevenGameGPEnv env) {
		int rank = Cards.getRank(env.card);
		
		if (rank == 6) {
			return countEnemyCardsInRange(env, 0, 12) - 1;
		}
		else if (rank < 6) {
			return countEnemyCardsInRange(env, 0, rank - 1);
		}
		else if (rank > 6) {
			return countEnemyCardsInRange(env, rank + 1, 12);
		}
		else {
			throw new RuntimeException("Bad...");
		}
	}

	private int countEnemyCardsInRange(SevenGameGPEnv env, int low, int high) {
		int suit = Cards.getSuit(env.card);
		
		if (low > high) {
			return 0;
		}
		
		int count = 0;
		for (int i = low; i <= high; ++i) {
			int card = suit * 13 + i;
			int owner = env.game.getCardOwner(card);
			
			if (owner >= 0 && owner != env.player) { //check >= 0 is because no owner (played card) is signaled by -1
				count += 1;
			}
		}
		
		return count;
	}

	@Override
	public String getPrefix() {
		return "block";
	}
	
	@Override
	protected String combineLuaExpr(String[] opValues) {
		return "env.block";
	}
}
