package se.petterhansson.sevengp.gp.alphabet;

import se.petterhansson.sevengp.game.Cards;


public class DistTerminal extends SevenGPNode {
	public DistTerminal() {
		super(0);
	}

	@Override
	public float getValue(SevenGameGPEnv env) {
		int suit = Cards.getSuit(env.card);
		int rank = Cards.getRank(env.card);
		
		int lowest = env.game.getLowestInSuit(suit);
		int highest = env.game.getHighestInSuit(suit);
		if (lowest == -1 || highest == -1) {
			return 6;
		}
		
		if (rank > 6) {
			return 12 - highest;
		}
		
		return lowest;
	}

	@Override
	public String getPrefix() {
		return "dist";
	}
	
	@Override
	protected String combineLuaExpr(String[] opValues) {
		return "env.dist";
	}
}
