package se.petterhansson.sevengp.gp.alphabet;


public class DivFunction extends SevenGPNode {
	public DivFunction() {
		super(2);
	}
	
	@Override
	public float getValue(SevenGameGPEnv env) {
		SevenGPNode lhs = (SevenGPNode) getChild(0);
		SevenGPNode rhs = (SevenGPNode) getChild(1);
		float lval = lhs.getValue(env);
		float rval = rhs.getValue(env);
		
		if (Math.abs(rval) < 0.0001f) {
			return 0.0f; //discontinuous but better than NaN
		}
		
		return lval / rval;
	}

	@Override
	public String getPrefix() {
		return "/";
	}
	
	@Override
	protected String combineLuaExpr(String[] opValues) {
		return opValues[0] + "/" + opValues[1];
	}
}
