package se.petterhansson.sevengp.gp.alphabet;


public class IfFunction extends SevenGPNode {
	public IfFunction() {
		super(4);
	}
	
	@Override
	public float getValue(SevenGameGPEnv env) {
		SevenGPNode lcomp = (SevenGPNode) getChild(0);
		SevenGPNode rcomp = (SevenGPNode) getChild(1);
		SevenGPNode lout = (SevenGPNode) getChild(2);
		SevenGPNode rout = (SevenGPNode) getChild(3);
		
		if (lcomp.getValue(env) < rcomp.getValue(env)) {
			return lout.getValue(env);
		}
		else
		{
			return rout.getValue(env);
		}
	}

	@Override
	public String getPrefix() {
		return "if";
	}
	
	@Override
	protected String combineLuaExpr(String[] opValues) {
		return "???"; //TODO: if it's ever going to be used
	}
}
