package se.petterhansson.sevengp.gp.alphabet;


public class LogFunction extends SevenGPNode {
	public LogFunction() {
		super(1);
	}
	
	@Override
	public float getValue(SevenGameGPEnv env) {
		SevenGPNode arg = (SevenGPNode) getChild(0);
		
		if (Math.abs(arg.getValue(env)) < 0.000001f) {
			return 0.0f; //discontinuous but better than NaN
		}
		
		return (float) Math.log(Math.abs(arg.getValue(env)));
	}

	@Override
	public String getPrefix() {
		return "log";
	}
	
	@Override
	protected String combineLuaExpr(String[] opValues) {
		return "math.log" + opValues[0];
	}
}
