package se.petterhansson.sevengp.gp.alphabet;


public class MinFunction extends SevenGPNode {
	public MinFunction() {
		super(2);
	}
	
	@Override
	public float getValue(SevenGameGPEnv env) {
		SevenGPNode lhs = (SevenGPNode) getChild(0);
		SevenGPNode rhs = (SevenGPNode) getChild(1);
		
		return Math.min(lhs.getValue(env), rhs.getValue(env));
	}

	@Override
	public String getPrefix() {
		return "min";
	}
	
	@Override
	protected String combineLuaExpr(String[] opValues) {
		return "math.min(" + opValues[0] + "," + opValues[1] + ")";
	}
}
