package se.petterhansson.sevengp.gp.alphabet;

import se.petterhansson.sevengp.game.Cards;


public class SafeTerminal extends SevenGPNode {
	public SafeTerminal() {
		super(0);
	}

	@Override
	public float getValue(SevenGameGPEnv env) {
		int rank = Cards.getRank(env.card);
		
		boolean safeDown = env.card == 0 || env.game.getCardOwner(env.card - 1) == env.player;
		boolean safeUp = env.card == 51 || env.game.getCardOwner(env.card + 1) == env.player;
		
		if (rank == 0 || rank == 12) {
			return 1; //king and ace are 'safe', they do not open anything
		}
		else if (rank == 6) {
			return (safeDown && safeUp)? 1 : 0;
		}
		else if (rank < 6) {
			return safeDown? 1 : 0;
		}
		else if (rank > 6) {
			return safeUp? 1 : 0;
		}
		else {
			throw new RuntimeException("Bad...");
		}
	}

	@Override
	public String getPrefix() {
		return "safe";
	}
	
	@Override
	protected String combineLuaExpr(String[] opValues) {
		return "env.safe";
	}
}
