package se.petterhansson.sevengp.gp.alphabet;

import se.petterhansson.sevengp.game.Cards;


public class SelfBlockTerminal extends SevenGPNode {
	public SelfBlockTerminal() {
		super(0);
	}

	@Override
	public float getValue(SevenGameGPEnv env) {
		int rank = Cards.getRank(env.card);
		
		if (rank == 6) {
			return countFriendlyCardsInRange(env, 0, 12) - 1;
		}
		else if (rank < 6) {
			return countFriendlyCardsInRange(env, 0, rank - 1);
		}
		else if (rank > 6) {
			return countFriendlyCardsInRange(env, rank + 1, 12);
		}
		else {
			throw new RuntimeException("Bad...");
		}
	}

	private int countFriendlyCardsInRange(SevenGameGPEnv env, int low, int high) {
		int suit = Cards.getSuit(env.card);
		
		if (low > high) {
			return 0;
		}
		
		int count = 0;
		for (int i = low; i <= high; ++i) {
			int card = suit * 13 + i;
			if (env.game.getCardOwner(card) == env.player) {
				count += 1;
			}
		}
		
		return count;
	}

	@Override
	public String getPrefix() {
		return "selfblock";
	}
	
	@Override
	protected String combineLuaExpr(String[] opValues) {
		return "env.selfblock";
	}
}
