package se.petterhansson.sevengp.gp.alphabet;

import se.petterhansson.gp.GPNode;

public abstract class SevenGPNode extends GPNode {
	public SevenGPNode(int arity) {
		super(arity);
	}

	public abstract float getValue(SevenGameGPEnv env);
	
	public void alterMagnitudes() {
		for (int i = 0, n = getArity(); i < n; ++i) {
			SevenGPNode child = (SevenGPNode) getChild(i);
			if (child != null) {
				child.alterMagnitudes();
			}
		}
	}
	
	abstract protected String combineLuaExpr(String[] opValues);
	
	/**
	 * Returns a Lua expression tree for the computation of tree at this node.
	 * I make no effort to make this less computationally expensive (StringBuilder shuffling).
	 * @return
	 */
	public String getLuaExpr() {
		String[] values = new String[getArity()];
		
		for (int i = 0, n = getArity(); i < n; ++i) {
			SevenGPNode child = (SevenGPNode) getChild(i);
			
			if (child != null) {
				values[i] = child.getLuaExpr();
			}
		}
		
		return "(" + combineLuaExpr(values) + ")";
	}
}
