package se.petterhansson.util;

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;

public class MultiOutputStream extends OutputStream {
	private final List<OutputStream> streams;

	public MultiOutputStream(List<OutputStream> streams) {
		this.streams = streams;
	}
	
	public MultiOutputStream(OutputStream[] streams) {
		this.streams = new ArrayList<OutputStream>();
		
		for (int i = 0; i < streams.length; ++i) {
			this.streams.add(streams[i]);
		}
	}

	@Override
	public void write(int b) throws IOException {
		for (OutputStream os : streams) {
			os.write(b);
		}
	}
	
	@Override
	public void write(byte[] b, int off, int len) throws IOException {
		for (OutputStream os : streams) {
			os.write(b, off, len);
		}
	}
}
